package cz.jzitnik.game;

import cz.jzitnik.game.sprites.*;
import cz.jzitnik.tui.Sprite;
import cz.jzitnik.tui.SpriteList;

import java.util.HashMap;

public class SpriteLoader {
    public enum SPRITES {
        AIR,
        DIRT,
        GRASS,
        STEVE,
        STONE,
        BEDROCK
    }

    public static final HashMap<SPRITES, Sprite> SPRITES_MAP = new HashMap<>();

    static {
        SPRITES_MAP.put(SPRITES.AIR, new Air());
        SPRITES_MAP.put(SPRITES.DIRT, new Dirt());
        SPRITES_MAP.put(SPRITES.GRASS, new Grass());
        SPRITES_MAP.put(SPRITES.STONE, new Stone());
        SPRITES_MAP.put(SPRITES.STEVE, new Steve());
        SPRITES_MAP.put(SPRITES.BEDROCK, new Bedrock());
    }

    public static SpriteList<SPRITES> load() {
        return new SpriteList<>(SPRITES.class, SPRITES_MAP);
    }
}
