package cz.jzitnik.tui;

public class SpriteCombiner {
    public static String combineSprites(String[] sprites) {
        if (sprites == null || sprites.length == 0) {
            return "";
        }

        String combinedSprite = sprites[0];

        for (int i = 1; i < sprites.length; i++) {
            combinedSprite = combineTwoSprites(combinedSprite, sprites[i]);
        }

        return combinedSprite;
    }


    private static String combineTwoSprites(String sprite1, String sprite2) {
        String[] rows1 = sprite1.split("\n");
        String[] rows2 = sprite2.split("\n");

        StringBuilder combinedSprite = new StringBuilder();

        for (int i = 0; i < 25; i++) {
            String row1 = rows1[i];
            String row2 = rows2[i];
            StringBuilder combinedRow = new StringBuilder();

            int cursor1 = 0;
            int cursor2 = 0;

            while (cursor2 < row2.length()) {
                String color1 = extractColorCode(row1, cursor1);
                char pixel1 = row1.charAt(cursor1 + color1.length());
                String color2 = extractColorCode(row2, cursor2);
                char pixel2 = row2.charAt(cursor2 + color2.length());

                if (color2.equals("\033[0m") && pixel2 == ' ') {
                    combinedRow.append(color1).append(pixel1);
                } else {
                    combinedRow.append(color2).append(pixel2);
                }

                cursor1 += color1.length() + 1;
                cursor2 += color2.length() + 1;
            }

            combinedSprite.append(combinedRow).append("\n");
        }

        return combinedSprite.toString();
    }
    private static String extractColorCode(String row, int index) {
        StringBuilder colorCode = new StringBuilder();

        if (row.charAt(index) == '\033') {
            while (index < row.length() && row.charAt(index) != 'm') {
                colorCode.append(row.charAt(index));
                index++;
            }
            colorCode.append('m');
        }

        return colorCode.toString();
    }
}
